// Check if the element is an image
function PhotoMEContextPopupShowing()
{
	if (gContextMenu != undefined)
	{
		if (gContextMenu.onImage || gContextMenu.onStandaloneImage)
		{
			gContextMenu.showItem("photome", true);
		}
		else
		{
			gContextMenu.showItem("photome", false);
		}

/*
		if (gContextMenu.hasBGImage)
		{
			gContextMenu.showItem("photome_bg", true);
		}
		else
		{
			gContextMenu.showItem("photome_bg", false);
		}
*/
	}
}

var gStrBundle;

function OpenPhotoME(url)
{
	gStrBundle = document.getElementById("bundle_photome");

	var tmpfile;
	if (url)
	{
		var fu = new PhotoMeFileUtils();
		launchyShared.trace("URL <" + url + ">");

		var d = new Date().getTime();
		var du = new PhotoMeDirUtils();
		tmpfile = fu.append(du.getTmpDir(), "photome-" + d);
		launchyShared.trace("Temporary file <" + tmpfile + ">");

		var f = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		f.initWithPath(tmpfile);

		const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
		var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(nsIWBP);
		persist.persistFlags = nsIWBP.PERSIST_FLAGS_FROM_CACHE | nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES | nsIWBP.PERSIST_FLAGS_DONT_CHANGE_FILENAMES | nsIWBP.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;

		if (url.substr(0,4) == "imap")
		{
			var URI = Components.classesByID["{21a89611-dc0d-11d2-806c-006008128c4e}"].createInstance(Components.interfaces.nsIURI);
		}
		else if (url.substr(0,7) == "mailbox")
		{
			var URI = Components.classes["@mozilla.org/messenger/mailboxurl;1"].createInstance(Components.interfaces.nsIURI);
		}
		else if (url.substr(0,4) == "news")
		{
			var URI = Components.classes["@mozilla.org/messenger/nntpurl;1"].createInstance(Components.interfaces.nsIURI);
		}
		else
		{
			alert("Unknown protocol type: " + url.substr(0, uri.indexOf(":")));
		}

		// var URI = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
		// var URI = Components.classes["@mozilla.org/messenger/mailboxurl;1"].createInstance(Components.interfaces.nsIURI);
		URI.spec = url;

		launchyShared.trace("Trying to save URL <" + url + ">");

		try
		{
			persist.saveURI(URI, null, null, null, null, f);
		}
		catch (ex)
		{
			launchyShared.trace("Cannot save URL <" + url + "> due to:\n" + ex);
			alert("Cannot save URL <" + url + "> due to:\n" + ex);
			return;
		}

		var app_path = GetAppPath("SOFTWARE\\PhotoME", "AppPath");
		if (app_path.length == 0)
		{
			var app_exe = GetAppPath("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\PhotoME.exe", "");
		}
		else
		{
			var app_exe = app_path + "photome.exe";
		}

		var args = new Array;
		args[0] = "ff:" + tmpfile + "|" + url;

		launchyShared.trace("About to run:\n" + app_exe + " " + args);

		try
		{
			fu.spawn(app_exe, args);
		}
		catch(ex)
		{
			launchyShared.trace("PhotoME could not be found.");
			alert(gStrBundle.getString("PhotoMeNotFound"));
		}
	}
	else
	{
		launchyShared.trace("Unable to get URL");
		alert(gStrBundle.getString("UnableToGetUrl"));
	}
}

function GetAppPath(SubKey, ValueName)
{
	var winhooks;
	if ("@mozilla.org/windows-registry-key;1" in Components.classes)
	{
		try
		{
			winhooks = Components.classes["@mozilla.org/windows-registry-key;1"].getService(Components.interfaces.nsIWindowsRegKey);
		}
		catch(ex)
		{
			launchyShared.trace("Unable to get windows-registry-key service!");
		}

		if (typeof(winhooks) == "undefined"	|| typeof(winhooks.open) != "function")
		{
			winhooks = false;
			launchyShared.trace("nsIWindowsRegKey:open isn't available. This only works on Windows!");
			alert(gStrBundle.getString("nsIWindowsRegKeyOpenNotAvailable"));

			return "";
		}
	}
	else if ("@mozilla.org/winhooks;1" in Components.classes)
	{
		try
		{
			winhooks = Components.classes["@mozilla.org/winhooks;1"].getService(Components.interfaces.nsIWindowsRegistry);
		}
		catch(ex)
		{
			launchyShared.trace("Unable to get winhooks service!");
		}

		if (typeof(winhooks) == "undefined" || typeof(winhooks.getRegistryEntry) != "function")
		{
			winhooks = false;
			launchyShared.trace("getRegistryEntry isn't available. This only works on Windows!");
			alert(gStrBundle.getString("getRegistryEntryNotAvailable"));

			return "";
		}
	}
	else if ("@mozilla.org/browser/shell-service;1" in Components.classes)
	{
		try
		{
			winhooks = Components.classes["@mozilla.org/browser/shell-service;1"].getService(Components.interfaces.nsIWindowsShellService);
		}
		catch(ex)
		{
			launchyShared.trace("Unable to get browser shell service!");
		}

		if (typeof(winhooks) == "undefined" || typeof(winhooks.getRegistryEntry) != "function")
		{
			winhooks = false;
			launchyShared.trace("getRegistryEntry isn't available. This only works on Windows!");
			alert(gStrBundle.getString("getRegistryEntryNotAvailable"));

			return "";
		}
	}
	else
	{
		launchyShared.trace("Unable to get Components. This only works on Windows!");
		alert(gStrBundle.getString("UnableToGetComponents"));
		return "";
	}

	if(winhooks)
	{
		try
		{
			if(typeof(winhooks.open) != "function")
			{
				// 3 = HKEY_LOCAL_MACHINE
				var strApp = winhooks.getRegistryEntry("3", SubKey, ValueName);

				return strApp;
			}
			else
			{
				winhooks.open(Components.interfaces.nsIWindowsRegKey.ROOT_KEY_LOCAL_MACHINE, SubKey, Components.interfaces.nsIWindowsRegKey.ACCESS_READ);
				var strApp = winhooks.readStringValue(ValueName);

				return strApp;
			}
		}
		catch(ex)
		{
			return "";
		}
	}
	else
	{
		return "";
	}
}

function InitPhotoMEOverlay()
{
	CleanTempFile();

	document.getElementById("messagePaneContext").addEventListener("popupshowing", PhotoMEContextPopupShowing, false);
	document.getElementById("attachmentListContext").addEventListener("popupshowing", PhotoMEContextPopupShowing, false);
}

function CleanTempFile()
{
	var du = new PhotoMeDirUtils();
	var contents = new PhotoMeDir(du.getTmpDir()).readDir();
	var re = /^photome-(\d+)\./i;
	var u = new Date().getTime();

	for (var i = 0; i < contents.length; i++)
	{
		if (contents[i].isFile())
		{
			var x = contents[i].leaf.match(re);
			if (x && x[1])
			{
				if (u - parseInt(x[1]) > 60 * 60 * 24 * 1000)
				{
					launchyShared.trace("Deleting old view files <" + contents[i].path + ">");
					contents[i].remove();
				}
			}
		}
	}
}

window.addEventListener("load", InitPhotoMEOverlay, false);